/* tcp-web-server.h
// TE816 - Modelagem e Avaliação de Desempenho
// Pós Graduação em Engenharia Elétrica
// Universidade Federal do Paraná
// This souce was developed as basis for homework 
//
// -- 10/11/2018
// ==================================
// Prof. Carlos Marcelo Pedroso
// pedroso@eletrica.ufpr.br
// http://www.eletrica.ufpr.br/pedroso
// Universidade Federal do Paraná
// Departamento de Engenharia Elétrica
// Centro Politécnico
// CEP: 81531-990 - Curitiba - PR - Brasil
 */

#ifndef TCP_WEB_SERVER
#define TCP_WEB_SERVER

#include "ns3/application.h"
#include "ns3/event-id.h"
#include "ns3/ptr.h"
#include "ns3/address.h"

namespace ns3 {

class Socket; 
class Packet;

/**
 * Recieve a request and send a page back to client
 */
class TcpWebServer : public Application
{
public:
  static TypeId GetTypeId (void);
  TcpWebServer ();
  virtual ~TcpWebServer ();

  /**
   *
   * Receive the packet from client web on socket level (layer 4), 
   * handle the packet and return a page to the client.
   */
  void ReceivePacket(Ptr<Socket> socket);
  
  /**
  *
  * Handle packet from accept connections.
  *
  */
  void HandleAccept (Ptr<Socket> s, const Address& from);
  
  /**
  *
  * Handle successful closing connections.
  *
  */
  void HandleSuccessClose(Ptr<Socket> s);
  void SetDataSize (uint32_t dataSize);
  uint32_t GetDataSize (void) const;

protected:
  virtual void DoDispose (void);

private:

  virtual void StartApplication (void);
  virtual void StopApplication (void);

  void HandleRead (Ptr<Socket> socket);

  Ptr<Socket> m_socket;
  Ptr<Socket> m_socket6;
  uint16_t m_port;
  bool m_running;
  uint32_t m_avgPageSize; 
};

} // namespace ns3

#endif /* TCP_WEB_SERVER */

